# -*- coding: utf-8 -*-
"""
Created on Thu May 30 21:17:42 2013
@author: Timchen525
"""
import numpy as np
import matplotlib.pyplot as plt
import pandas as pd
import matplotlib.dates as mdates
import xlrd
import datetime
from numpy import shape
import padasip as pa
from scipy import optimize
import subprocess
import math
from scipy.fftpack import fft,ifft
from sklearn import preprocessing

lightInner=[0]
lightOuter=[0]
lightCal=[0]
itr1 = 2500-1
itr2 = 0
itr = itr1+itr2
start=[30,138,222,320,412,510,610,711,819,896,991, 1087,1185,1280,1376,1470,1569,1680,1760,1859,1954,2049,2145,2244,2338,2434]
stop =[65,158,257,351,445,545,642,735,832,930,1025,1120,1217,1312,1408,1505,1600,1695,1791,1887,1983,2079,2175,2269,2366,2464]
tspan=[]
mean_dn_slice_month=[]
mean_yn_slice_month=[]
mean_x1n_slice_month=[]
mean_xn_slice_month=[]
tal_cal=[]
delta=[]

rRMSE_cal=[]
lms_full=[] #白天lms输出数据集合
sen_full=[] #白天室内传感器输出数据集合

date_slice=[]  
solarZenith=[]
clearness = []

overcast = [2,8]#[2,8,14]
mild = [5,10,24]#[5,10,23]
sunny = [11,12]#[1,11,12]
overall = [2,8,5,10,11,12,9]
abnormal = [9]
innerTemprature = []
GDD = [1252, 1257.4, 1261.8385416666667, 1267.959375, 1273.4947916666667,
       1278.6625, 1284.4510416666667, 1290.028125, 1292.040625, 1294.9864583333333,
       1298.33125, 1299.4833333333333, 1298.4416666666666, 1295.9208333333333, 1291.8375,
       1288.5052083333333, 1286.1364583333334, 1289.2010416666667, 1293.3635416666666, 1299.0322916666667,
       1305.415625, 1313.0333333333333, 1320.0166666666667, 1327.3239583333334, 1332.196875,
       1338.7197916666667]

sum1 = 0
sum2 = 0
mean1 = 0
rrmse = 0
rr = 0

innerAccordingClearness=[]
beam=[]
diffuse=[]
myDpi = 600

innerPowerF1 = []
innerPowerSensor = []
        
#28号光照数据读取
workbook = xlrd.open_workbook('./values_in_copy.xlsx')
booksheet = workbook.sheet_by_name('Sheet1')
for i in range(2 , itr1+2):

        lightInner.append(booksheet.cell_value(i, 6))

print(len(lightInner))
print(lightInner[10])


'''
for i in range(447219 , 447219+itr*4):
    if i%4 == 0:
        lightInner.append(booksheet.cell_value(i, 1))
lightInner.pop()
#lightInner.pop()

print(len(lightInner))
'''

#外部光照数据读取
workbook1 = xlrd.open_workbook('./values_out-12.xlsx')
## flie name  = values_in1\\values_out-12
booksheet1 = workbook1.sheet_by_name('Sheet1')
for i in range(2,itr1+2):
    lightOuter.append(booksheet1.cell_value(i,6))

 

#print(len(lightOuter))
#print(lightOuter[10])

#公式计算室内太阳辐射值
workbook2 = xlrd.open_workbook('./values_in_copy.xlsx')
## flie name  = values_in1\\values_out-12\\values_in _copy
booksheet2 = workbook2.sheet_by_name('Sheet1')
for i in range(2 , itr1+2):
    lightCal.append(booksheet2.cell_value(i,7))


#太阳高度角数据读取
workbook3 = xlrd.open_workbook('./values_in_copy.xlsx')
## flie name  = values_in1\\values_out-12
booksheet3 = workbook3.sheet_by_name('Sheet1')
for i in range(2,itr1+2):
    solarZenith.append(booksheet3.cell_value(i,5))

#室内温度数据读取
workbook4 = xlrd.open_workbook('./values_in_copy.xlsx')
## flie name  = values_in1\\values_out-12
booksheet4 = workbook4.sheet_by_name('Sheet1')
for i in range(2,itr1+2):
    innerTemprature.append(booksheet4.cell_value(i,0))  


#定义向量的内积
def multiVector(A,B):
    C=np.zeros(len(A))
    for i in range(len(A)):
        C[i]=A[i]*B[i]
    return sum(C)

#取定给定的反向的个数
def inVector(A,b,a):
    D=np.zeros(b-a+1)#
    for i in range(b-a+1):#
        D[i]=A[i+a]
    return D[::-1]

#lMS算法的函数
def LMS(xn,dn,M,mu,itr):
    en=np.zeros(itr)
    en1=np.zeros(itr);
    W=[[0]*M for i in range(itr)]
    R=[[0]*M for i in range(itr)]
    for k in range(itr)[M-1:itr]:

        x=inVector(xn,k,k-M+1)
        y=multiVector(W[k-1],x)
        en[k]=dn[k]-y
        R[k]=np.dot(x.T,x)

        #W[k]=np.add(W[k-1],2*mu*en[k]*x/(np.dot(x,x)+2.22e-16)) #跟新权重
        W[k]=np.add(W[k-1],2*mu*en[k]*x) #跟新权重
        #W[k]=np.add(W[k-1],4*mu*en[k]*en[k]*en[k]*x) #LM4
        '''
        x=inVector(dn,k,k-M+1)
        y=multiVector(W[k-1],dn)
        en[k]=xn[k]-y
        W[k]=np.add(W[k-1],2*mu*en[k]*x) #跟新权重
        '''
    #求最优时滤波器的输出序列
    yn=1.0*np.ones(len(xn))
    for k in range(len(xn))[M-1:len(xn)]:
        x=inVector(xn,k,k-M+1)
        yn[k]=1.0*multiVector(W[len(W)-1],x)

    return (yn,en,en1,W,R)
#mean of a vector
def sumVector(A):
    acc = 0
    for i in range(len(A)):
        acc += A[i]
    return acc/len(A)
#mean squared of a vector
def MeanSquere(A,mean):
    acc = 0
    for i in  range(len(A)):
        acc +=(A[i]-mean)*(A[i]-mean)
    return acc/len(A)

def nlms(x, d, h, step_size=0.5):
   i = len(h)
   size = len(x)
   # 计算输入到h中的参照信号的乘方he
   power = np.sum( x[i:i-len(h):-1] * x[i:i-len(h):-1] )
   u = np.zeros(size, dtype=np.float64)

   while True:
       x_input = x[i:i-len(h):-1]
       u[i] = np.dot(x_input , h)
       e = d[i] - u[i]
       h += step_size * e / power * x_input

       power -= x_input[-1] * x_input[-1] # 减去最早的取样
       i+=1
       if i >= size: return u
       power += x[i] * x[i] # 增加最新的取样

def convertSVGtoEMF(figname):
    cmd = 'inkscape -z %s.svg -M %s.emf' % (figname, figname)
    result = [] # 储存cmd中结果
    process = subprocess.Popen(cmd,
                               shell=True,
                               stdout=subprocess.PIPE,
                               stderr=subprocess.PIPE)
    for line in process.stdout:
        result.append(line)
    errcode = process.returncode
    for line in result:
        print(line)
    if errcode is not None:
        raise Exception('cmd %s failed, see above for details', cmd)
def CorrlationCal(x,startID, endID, L):
    sum = 0;
    x_part = x[startID:endID].T
    for i in range(len(x_part)):
        sum = sum + x_part[i]*x_part[i]
    print("sum x^2 is",sum)
    print("x_part is",x_part)
    x_new = [L*[0] for i in range(L)]
    for j in range(L):
        for i in range(L):
            x_new[i][j] = x_part[j]*x_part[i]

    return x_new

def CorrelationCalShift(x,startID1,endID1,startID2,endID2,L,mean):
    sum = 0;
    x_part1=x[startID1:endID1].T
    x_part2=x[startID2:endID2].T
    if  mean==0:
        for i in range(L):
            sum = sum  + x_part1[i]*x_part2[i]
    else:
        for i in range(L):
            sum = sum  + (x_part1[i]-sumVector(x_part1))*(x_part2[i]-sumVector(x_part2))

    return sum
def rRMSE(x,y,startID,endID,shift):
        rmse = 0
        rRMSE = 0
        mean = 0
        lenth = endID-startID+1

        mean  = sumVector(y[startID:endID])
        for i in range(startID,endID):
                rmse += pow((x[i+shift]-y[i]),2)
        
         
        rmse = np.sqrt(rmse/lenth)
        rRMSE = rmse/mean
        
        return (rmse ,rRMSE)

def Mae(x,y,startID,endID,shift):
        mae = 0
        
        lenth = endID-startID+1
       
        for i in range(startID,endID):
                mae += abs(x[i+shift]-y[i])
        mae /= lenth
        
        
        return (mae)
def RR_Cal(estimation ,sensor ,startID,endID,shift):
        rr = 0
        sum1 = 0
        sum2 = 0
        meanSensor = sumVector(sensor)
        maneEstimation = 0
        
        lenth = endID-startID+1

        for i in range(len(estimation)-shift):
                sum1 += math.pow((estimation[i+shift] - sensor[i]),2)

        for i in range(len(sensor)-shift):
                sum2 += math.pow((sensor[i]-meanSensor),2)

        rr = 1 - sum1/sum2

        return rr
def Thd_Cal(xn):
        thd = 0
        sum1 = 0
        for i in range(2,int(len(xn))-1):
                sum1 += xn[i]*xn[i]
        thd = np.sqrt(sum1/math.pow(xn[1],2))

        return thd

def InterCor_Cal(xk,yk,shiftMax):

    xk_temp = xk
    yk_temp = yk

    sum1 = []
    cor = 0
    len1 = min(len(xk_temp),len(yk_temp))

    
    for j in range(0,shiftMax):
        for i in range(0,len1):
           cor += xk_temp[i]*yk_temp[i]
        sum1.append(cor)
        cor = 0
        xk_temp.insert(0,xk_temp.pop())
    #print(sum1)
    #print(sum1.index(max(sum1)))
    return(sum1.index(max(sum1)))

def Normalization(xk):
        xk_temp = xk
        len1 = len(xk_temp)
        max1 = max(xk_temp)

        for i in range(len(xk_temp)):
                if(max1 != 0):
                        xk_temp[i] /= max1
        return xk_temp
                
##############Decomposition of beam and diffuse#############################

def SolarRadiation_Decomposition(solarradiation,kt):
        beam = []
        diffuse = []
        

        for i in range(len(kt)):
                if(kt[i]<0.175):
                        diffuse.append(0.95*solarradiation[i])
                        beam.append((1-0.95)*solarradiation[i])
                if(0.175<kt[i]<0.775):
                        diffuse.append((0.9698+0.4353*kt[i]-3.4499*pow(kt[i],2)+2.1888*pow(kt[i],3))*solarradiation[i])
                        beam.append((1-(0.9698+0.4353*kt[i]-3.4499*pow(kt[i],2)+2.1888*pow(kt[i],3)))*solarradiation[i])
                if(kt[i]>0.775):
                        diffuse.append(0.26*solarradiation[i])
                        beam.append((1-0.26)*solarradiation[i])
        return(beam, diffuse)
#######################inner Solar Radiation Calculation####################
def InnerSolarRadiation_Cal(beam,diffuse,talB,talD):
        innerSolarRadiation = []
        for i in range(len(beam)):
                innerSolarRadiation.append((beam[i]*talB+diffuse[i]*talD))
        return innerSolarRadiation
        
        
##############linear function####################
def f_1(x, A, B):
        return A*x + B
##############linear function fitting############
def linearFunctionFit(x,y):
    a = 0
    b = 0

    a, b=optimize.curve_fit(f_1,x,y)[0]

    return  a, b
a1 = -0.335
a2 = 4.803
a3 = 755.3
a4 = 134.7
b1 = 0.946
b2 = 0.188
lamda =2.45
k = 0.69
t_sum = 1100
#time_span = 8
def volCal(radiation,time_span,gdd):
    volumn = 0
    LAI = a1 + (a2 - a1)/(1 + math.exp((a3 - gdd)/a4));
    tempRadiation = radiation*60*60*time_span/math.pow(10,6);
    volume = (b1 *(1 - math.exp(-k * LAI))*tempRadiation / lamda + b2)*1000/4;
    volumeH = round(volume/time_span);
    return volume                
       

if __name__=="__main__":
    #参数初始化
    #itr=len(lightInner) #采样的点数
    M=9 #滤波器的阶数
    mu= 0.0005 #步长因子
    t=np.linspace(0,itr1,itr1+1)
    shift = 3
    print(t)
    #xn = np.zeros(itr, )
    #dn = np.zeros(itr, dtype=np.int)
    
    #dn = 0.01*np.array(xn,dtype='float64')
    cal=1.0*np.array(lightCal,dtype='float64')
    x1n=0.01*np.array(lightInner,dtype='float64')
    #print("len of xn",len(xn))

    #print("len of dn",len(dn))
    #调用LMS算法
    
    floor = math.pow(10,-20)
    print(floor)
    ####################clearness calculation##############################
    
    dayliAvrClearness = []
    sliceTemp=[]
    startDate = datetime.datetime(2017,12,1)
    #startDate1 = int(startDate.strftime("%startDate"))
    dateOrder =  int(startDate.strftime("%j")) 
    for i in range(len(solarZenith)):
            timedelta = int(i/96)
            I0 = 1366*(1+0.033*np.cos(np.deg2rad(360*(dateOrder+timedelta)/365)))*np.sin(np.deg2rad(solarZenith[i]))
            Ih = lightOuter[i]
            if(solarZenith[i] == 0):
                 temp = 0
            else:
                 temp=Ih/I0
            clearness.append(temp)
    for i in range(len(stop)):
            sliceTemp=clearness[start[i]:stop[i]]
            dayliAvrClearness.append(sumVector(sliceTemp))
   
            
            
    ################Inner Solar Radiation Calculation accroding clearness index#################
    beam,diffuse = SolarRadiation_Decomposition(lightOuter,clearness)
    tal_b = 0.88
    tal_d = 0.65
    print("tal_b is ",tal_b,"tal_d is ",tal_d)
    innerAccordingClearness = InnerSolarRadiation_Cal(beam,diffuse,tal_b,tal_d)#zuichu 0.92 0.85*0.72 and 0.75 0.85 is very good
    innerAccordingClearness.append(0)
    
    xn = 0.01*np.array(lightOuter,dtype='float64')+ 0.00005* np.random.randn(itr+1)
    dn = 0.01*np.array(innerAccordingClearness,dtype='float64') #对于自适应对消器，用dn作为期望,71%透射率
    (yn,en,en1,W2,R2)=LMS(xn,dn,M,0.00005,itr)
    mse1=[]
    err1=[]
    mseFS1=[]
    yn_1=yn
    for i in range(len(yn)-4):
        if(en[i]*en[i]>floor):
            mse1.append(10000*math.pow(yn[i+shift]-dn[i],2))
            err1.append(100*math.pow(yn[i+shift]-dn[i],1))
            mseFS1.append(10000*math.pow(yn[i+shift]-x1n[i],2))


    xn = 0.01*np.array(lightOuter,dtype='float64')
    dn = 0.01*np.array(innerAccordingClearness,dtype='float64') #对于自适应对消器，用dn作为期望,71%透射率
    (yn,en,en1,W2,R2)=LMS(xn,dn,M,0.0002,itr)
    mse2=[]
    err2=[]
    mseFS2=[]
    yn_2=yn
    for i in range(len(yn)-4):
        if(en[i]*en[i]>floor):
            mse2.append(10000*math.pow(yn[i+shift]-dn[i],2))
            err2.append(100*math.pow(yn[i+shift]-dn[i],1))
            mseFS2.append(10000*math.pow(yn[i+shift]-x1n[i],2))


    xn = 0.01*np.array(lightOuter,dtype='float64')
    dn = 0.01*np.array(innerAccordingClearness,dtype='float64') #对于自适应对消器，用dn作为期望,71%透射率
    (yn,en,en1,W2,R2)=LMS(xn,dn,M,0.0005,itr)
    mse5=[]
    err5=[]
    mseFS5=[]
    yn_5=yn
    for i in range(len(yn)-4):
        if(en[i]*en[i]>floor):
            mse5.append(10000*math.pow(yn[i+shift]-dn[i],2))
            err5.append(100*math.pow(yn[i+shift]-dn[i],1))
            mseFS5.append(10000*math.pow(yn[i+shift]-x1n[i],2))

    def intergratedLmsFunction(inputSignal ,desiredSignal , actualSignal,shiftX ,itr ,tapsN ,step,floor):
            localX=[]
            localY=[]
            localEn = []
            localEn1 = []
            localW=[[0]*M for i in range(itr)]
            localR=[[0]*M for i in range(itr)]

            localMse=[]
            localMseFs=[]
            localErr = []
            
            localX= inputSignal
            
            (localY,localEn,localEn1,localW,localR)=LMS(inputSignal,desiredSignal,tapsN,step,itr)
            for i in range(len(localY)-4):
                    if(math.pow(localEn[i],2)>floor):
                            localMse.append(10000*math.pow(localY[i+shift]-desiredSignal[i],2))
                            localMseFs.append(10000*math.pow(localY[i+shift]-actualSignal[i],2))
                            
            return(localMse,localMseFs)

    uRange = [0.00005,0.0001,0.0005]
    tapsRange = [9]
    print("u=", uRange[0])
    print("#########################")
 ####################tal_g calculation##############################
    tal_g = []
    tal_gDaily = []
    tal_gDailyAvr = []
    sliceOfSenIn = []
    sliceOfSenOut = []
    sliceOfSenInSum = []
    sliceOfSenOutSum = []
    for i in range(len(stop)):
            sliceOfSenIn.extend(x1n[start[i]:stop[i]])
            sliceOfSenOut.extend(xn[start[i]:stop[i]])
    for i in range(len(sliceOfSenOut)):
            if sliceOfSenOut == 0 :
                    tal_g.append(0)
            else:
                    tal_g.append(sliceOfSenIn[i]/sliceOfSenOut[i])
    
    for i in range(len(stop)):
            sliceOfSenInSum.append(sum(x1n[start[i]:stop[i]])/len(x1n[start[i]:stop[i]]))
            sliceOfSenOutSum.append(sum(xn[start[i]:stop[i]])/len(xn[start[i]:stop[i]]))
    for i in range(len(sliceOfSenInSum)):
            tal_gDaily.append(sliceOfSenInSum[i]/sliceOfSenOutSum[i])
    for i in range(len(tal_gDaily)):
            tal_gDailyAvr.append(sum(tal_gDaily)/len(tal_gDaily))
    print("talg avr is",tal_gDailyAvr[0])
    print("\n")
################FullMse cal#######################################xn VS dn 

    dataMatrix1 = []
    dataMatrix2 = []
    Mse1=[]
    Mse2=[]
    for i in uRange:
            for j in tapsRange:
                    Mse1, Mse2 = intergratedLmsFunction(xn ,dn , x1n, 4  ,2500 ,j ,i, 0)
                    dataMatrix1.extend(Mse1)
                    dataMatrix2.extend(Mse2)



                    
################Full Performance Calculation#######################################yn VS x1n 
                    
    finalRmseFs = []
    finalrRmseFs = []
    finalRrFs = []
    finalMaeFs=[]
    finalRmseCs = []
    finalrRmseCs = []
    finalRrCs = []
    finalMaeCs=[]
    yn_mix=[]
    sliceOfSen=[]
    sliceOfFil=[]
    sliceOfCal=[]
    
    for i in uRange:
            for j in tapsRange:
                   (yn,en,en1,W2,R2) = LMS(xn,dn,j,i,itr)
                   for k in range(len(stop)):     #put all valid data together
                           sliceOfSen.extend(x1n[start[k]:stop[k]])
                           sliceOfFil.extend(yn[start[k]+3:stop[k]+3])
                           sliceOfCal.extend(dn[start[k]:stop[k]])
                   
                   localTemp0, localTemp1 = rRMSE(sliceOfFil, sliceOfSen, 0,len(sliceOfSen)-1,0)
                   localRrFs = RR_Cal(sliceOfFil, sliceOfSen, 0,len(sliceOfSen)-1,0)
                   localMaeFs = Mae(sliceOfFil, sliceOfSen, 0,len(sliceOfSen)-1,0)
                   yn_mix.extend(yn)
                   finalRmseFs.append(localTemp0)
                   finalrRmseFs.append(localTemp1)
                   finalRrFs.append(localRrFs)
                   finalMaeFs.append(localMaeFs)

                   localTemp0, localTemp1 = rRMSE(sliceOfCal, sliceOfSen, 0,len(sliceOfSen)-1,0)
                   localRrCs = RR_Cal(sliceOfCal, sliceOfSen, 0,len(sliceOfSen)-1,0)
                   localMaeCs = Mae(sliceOfCal, sliceOfSen, 0,len(sliceOfSen)-1,0)
                   #yn_mix.extend(yn)
                   finalRmseCs.append(localTemp0)
                   finalrRmseCs.append(localTemp1)
                   finalRrCs.append(localRrCs)
                   finalMaeCs.append(localMaeCs)

                
    
    print("Rmse of yn and x1n is",finalRmseFs[0])
    print("rRmse of yn and x1n is",finalrRmseFs[0])
    print("R2 of yn and x1n is",finalRrFs[0])
    print("Mae of yn and x1n is",finalMaeFs[0])
    print("\n")
    print("Rmse of dn and x1n is",finalRmseCs[0])
    print("rRmse of dn and x1n is",finalrRmseCs[0])
    print("R2 of dn and x1n is",finalRrCs[0])
    print("Mae of dn and x1n is",finalMaeCs[0])
    
   
    print("\n")
########################################################################
    L=[2464,2433,2468]              #length of yn for M=9 L=2464// M=64 L=2433// M=128 L=2468
################daily Average Calculation###############################M=9
    
    dailyAvr1 = []#u=0.0001
    dailyAvr2 = []#u=0.0002
    dailyAvr5 = []#u=0.0005
    for i in uRange:
        (yn,en,en1,W2,R2) = LMS(xn,dn,9,i,itr)
        
        if (i==uRange[0]):
               
                  for j in range(len(stop)):
                      if (j != 10-1):
                          dailyAvr1.append(sumVector(yn_1[start[j]+3:stop[j]+3]))
                      else:
                          dailyAvr1.append(sumVector(yn_1[start[j]:stop[j]-1]))
                      W_Final = W2
        if (i==uRange[1]):
                  for j in range(len(stop)):
                      dailyAvr2.append(sumVector(yn[start[j]+4:stop[j]+4]))
        if (i==uRange[2]):
                  for j in range(len(stop)):
                      dailyAvr5.append(sumVector(yn[start[j]+4:stop[j]+4]))
                      
    dailyAvrSensor=[]
    dailyAvrCal=[]
    for j in range(len(stop)):
        dailyAvrSensor.append(sumVector(x1n[start[j]:stop[j]]))
        dailyAvrCal.append(sumVector(dn[start[j]:stop[j]]))
        
##################dayly performance calculation########################dailiAvr(u=0.0001/0.0002/0.0005) VS sensorAvr

    rmseDailyAvr=[]
    rrmseDailyAvr=[]
    rrDailyAvr=[]
    maeDailyAvr=[]
   
   
    localTemp0,localTemp1 = rRMSE(dailyAvr1, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)
    localTemp2 = RR_Cal(dailyAvr1, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)
    localTemp3 = Mae(dailyAvr1, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)

    rmseDailyAvr.append(localTemp0)
    rrmseDailyAvr.append(localTemp1)
    rrDailyAvr.append(localTemp2)
    maeDailyAvr.append(localTemp3)

    localTemp0,localTemp1 = rRMSE(dailyAvr2, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)
    localTemp2 = RR_Cal(dailyAvr2, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)
    localTemp3 = Mae(dailyAvr2, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)

    rmseDailyAvr.append(localTemp0)
    rrmseDailyAvr.append(localTemp1)
    rrDailyAvr.append(localTemp2)
    maeDailyAvr.append(localTemp3)

    localTemp0,localTemp1 = rRMSE(dailyAvr5, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)
    localTemp2 = RR_Cal(dailyAvr5, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)
    localTemp3 = Mae(dailyAvr5, dailyAvrSensor, 0,len(dailyAvrSensor)-1,0)

    rmseDailyAvr.append(localTemp0)
    rrmseDailyAvr.append(localTemp1)
    rrDailyAvr.append(localTemp2)
    maeDailyAvr.append(localTemp3)

    
##################daily time span calculation##########################
    localTemp0 = 0
    for i in range(len(stop)):
            localTemp0 = (stop[i]-start[i])*0.25
            tspan.append(localTemp0)
            
##################daily volume calculation#############################
    dailyVolumn1=[]
    dailyVolumn2=[]
    dailyVolumn5=[]
    dailyVolumnSensor=[]
    dailyVolumnCal=[]

    dailyVolumnDeltaFS1 = []
    dailyVolumnDeltaFS2 = []
    dailyVolumnDeltaFS5 = []
    dailyVolumnDeltaCS=[]
    
    for i in range(len(dailyAvr1)):
        
            dailyVolumn1.append(volCal(dailyAvr1[i]*100,tspan[i],GDD[i]))
            innerPowerF1.append(dailyAvr1[i]*100*tspan[i]*60*60/pow(10,6))
    #dailyVolumn1[9-1] = 250
       
    for i in range(len(dailyAvr2)):
        
            dailyVolumn2.append(volCal(dailyAvr2[i]*100,tspan[i],GDD[i]))
            
    for i in range(len(dailyAvr5)):
        
            dailyVolumn5.append(volCal(dailyAvr5[i]*100,tspan[i],GDD[i]))
            
    for i in range(len(dailyAvrSensor)):
       
            dailyVolumnSensor.append(volCal(dailyAvrSensor[i]*100,tspan[i],GDD[i]))
            innerPowerSensor.append(dailyAvrSensor[i]*100*tspan[i]*60*60/pow(10,6))

    for i in range(len(dailyAvrCal)):
        
            dailyVolumnCal.append(volCal(dailyAvrCal[i]*100,tspan[i],GDD[i]))

    for i in range(len(dailyVolumnSensor)):
            dailyVolumnDeltaFS1.append((dailyVolumn1[i]-dailyVolumnSensor[i])/dailyVolumnSensor[i])
            dailyVolumnDeltaFS2.append((dailyVolumn2[i]-dailyVolumnSensor[i])/dailyVolumnSensor[i])
            dailyVolumnDeltaFS5.append((dailyVolumn5[i]-dailyVolumnSensor[i])/dailyVolumnSensor[i])
            dailyVolumnDeltaCS.append((dailyVolumnCal[i]-dailyVolumnSensor[i])/dailyVolumnSensor[i])
##################daily volume performance#############################volumn(u=0.0001/0.0002/0,0005) VS volumn_sensor
    rmseDailyVolumn=[]
    rrmseDailyVolumn=[]
    rrDailyVolumn=[]
    maeDailyVolumn=[]
    
    localTemp0,localTemp1 = rRMSE(dailyVolumn1,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    
    localTemp2 = RR_Cal(dailyVolumn1,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp3 = Mae(dailyVolumn1,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)

    rmseDailyVolumn.append(localTemp0)
    rrmseDailyVolumn.append(localTemp1)
    rrDailyVolumn.append(localTemp2)
    maeDailyVolumn.append(localTemp3)

    localTemp0,localTemp1 = rRMSE(dailyVolumn2,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp2 = RR_Cal(dailyVolumn2,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp3 = Mae(dailyVolumn2,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)

    rmseDailyVolumn.append(localTemp0)
    rrmseDailyVolumn.append(localTemp1)
    rrDailyVolumn.append(localTemp2)
    maeDailyVolumn.append(localTemp3)
    
    localTemp0,localTemp1 = rRMSE(dailyVolumn5,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp2 = RR_Cal(dailyVolumn5,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp3 = Mae(dailyVolumn5,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)

    rmseDailyVolumn.append(localTemp0)
    rrmseDailyVolumn.append(localTemp1)
    rrDailyVolumn.append(localTemp2)
    maeDailyVolumn.append(localTemp3)

    

    print("rmse of dayliVolumnFil and dayliVolumnSensor ", rmseDailyVolumn[0])
    print("rrmse of dayliVolumnFil and dayliVolumnSensor ", rrmseDailyVolumn[0])
    print("rr of dayliVolumnFil and dayliVolumnSensor ", rrDailyVolumn[0])
    print("mae of dayliVolumnFil and dayliVolumnSensor ", maeDailyVolumn[0])
    print("\n")
    ##################daily volume performance#############################volumn_cal VS volumn_sensor
    rmseDailyVolumn=[]
    rrmseDailyVolumn=[]
    rrDailyVolumn=[]
    maeDailyVolumn=[]
    
    localTemp0,localTemp1 = rRMSE(dailyVolumnCal,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp2 = RR_Cal(dailyVolumnCal,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)
    localTemp3 = Mae(dailyVolumnCal,dailyVolumnSensor , 0,len(dailyVolumnSensor)-1,0)

   
    rmseDailyVolumn.append(localTemp0)
    rrmseDailyVolumn.append(localTemp1)
    rrDailyVolumn.append(localTemp2)
    maeDailyVolumn.append(localTemp3)

    

    print("rmse of dailyVolumnCal and dayliVolumnSensor ", rmseDailyVolumn)
    print("rrmse of dailyVolumnCal and dayliVolumnSensor ", rrmseDailyVolumn)
    print("rr of dailyVolumnCal and dayliVolumnSensor ", rrDailyVolumn)
    print("mae of dailyVolumnCal and dayliVolumnSensor ", maeDailyVolumn)
    print("\n")

    for i in overall:
            print("**************volume in Dec***************",i)
            print("Vc in dec-",i,"is",dailyVolumnCal[i-1])
            print("Vs in dec-",i,"is",dailyVolumnSensor[i-1])
            print("Vf in dec-",i,"is",dailyVolumn1[i-1])
            
            
    print("\n")

##################RR between daliyAverage clearness and daily volumn err#############################
    localTemp = RR_Cal(dayliAvrClearness,dailyVolumnDeltaFS1 , 0,len(dailyVolumnDeltaFS1)-1,0)
    print("RR of daliyAverage clearness and daily volumn err is", localTemp)
    print("\n")
##################ThD calculation####################################################################
    localY = []
    localFftY=[]
    localFftAbs=[]
    localThd = 0
    Thd = []
    for i in range(len(stop)):
            #if(i != 8):
            localY = xn[start[i]:stop[i]]
            for j in range(len(localY)):
                localY[j] -= sumVector(localY)
                
            localFftY = abs(fft(localY))
            for j in range(len(localFftY)):
                    localFftY[j] /= len(localFftY)
                    
            localThd = Thd_Cal(localFftY)
            Thd.append(localThd)          
##################RR between daliyAverage clearness and daily volumn err#############################
    localTemp = RR_Cal(Thd ,dailyVolumnDeltaFS1, 0,len(dailyVolumnDeltaFS1)-1,0)
    print("RR of thd and daily volumn err is", localTemp)
    print("\n")
##################curve fit############################################yn Vs x1n
    localSlice1 = []
    localSlice2 = []
    localSlice3 = []
    for i in range(len(stop)):
            localSlice1.extend(yn_1[start[i]+3:stop[i]+3])
            localSlice2.extend(x1n[start[i]:stop[i]])
            localSlice3.extend(dn[start[i]:stop[i]])
    A1,B1 = linearFunctionFit(localSlice2, localSlice1)
    print("A1, B1 is",A1, B1)
    print("\n")
##################curve fit############################################dn Vs x1n
    A3,B3 = linearFunctionFit(localSlice2, localSlice3)
    print("A3, B3 is",A3, B3)
    print("\n")
##################curve fit############################################dayliVolumnFil Vs dayliVolumnSensor
    
    A2,B2 = linearFunctionFit(dailyVolumnSensor,dailyVolumn1 )
    print("A2, B2 is",A2, B2)
    print("\n")
##################curve fit############################################dayliVolumncal Vs dayliVolumnSensor
    
    A4,B4 = linearFunctionFit(dailyVolumnSensor,dailyVolumnCal)
    print("A4, B4 is",A4, B4)
    print("\n")
 ##################curve fit############################################Pe-fs Vs daily average clearness index
    A5,B5 = linearFunctionFit(dayliAvrClearness,dailyVolumnDeltaFS1)
    print("A5, B5 is",A5, B5)
    print("\n")
 ##################curve fit############################################Pe-cs Vs daily average clearness index
    A6,B6 = linearFunctionFit(dayliAvrClearness,dailyVolumnDeltaCS)
    print("A6, B6 is",A6, B6)
    print("\n")
#################solar irrdiance estimation perfomance in diffrent data type###################################
    localSliceForDiffWeatherType=[]
    localSliceForDiffWearherType1 = []
    localTemp0=0
    localTemp1=0
    localTemp2=0
    localTemp3=0
    ############Sunny##############
    rmseSunny=[]
    rrmseSunny=[]
    rrSunny=[]
    maeSunny=[]

    rmseSunnyCs=[]
    rrmseSunnyCs=[]
    rrSunnyCs=[]
    maeSunnyCs=[]
    
    for i in sunny:
            localSliceForDiffWeatherType = yn_1[start[i-1]+3:stop[i-1]+3]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseSunny.append(localTemp0)
            rrmseSunny.append(localTemp1)
            rrSunny.append(localTemp2)
            maeSunny.append(localTemp3)

            
    print("rmse in Sunny is",rmseSunny)
    print("rrmse in Sunny is",rrmseSunny)
    print("rr in Sunny is",rrSunny)
    print("mae in Sunny is",maeSunny)
    print("\n")

    for i in sunny:
            localSliceForDiffWeatherType = dn[start[i-1]+3:stop[i-1]+3]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseSunnyCs.append(localTemp0)
            rrmseSunnyCs.append(localTemp1)
            rrSunnyCs.append(localTemp2)
            maeSunnyCs.append(localTemp3)

    print("rmseCs in Sunny is",rmseSunnyCs)
    print("rrmseCs in Sunny is",rrmseSunnyCs)
    print("rrCs in Sunny is",rrSunnyCs)
    print("maeCs in Sunny is",maeSunnyCs)
    print("\n")
    ############Mild##############
    rmseMild=[]
    rrmseMild=[]
    rrMild=[]
    maeMild=[]

    rmseMildCs=[]
    rrmseMildCs=[]
    rrMildCs=[]
    maeMildCs=[]
    
    for i in mild:
            if i!=10:
                localSliceForDiffWeatherType = yn_1[start[i-1]+3:stop[i-1]+3]
            else:
                localSliceForDiffWeatherType = yn_1[start[i-1]+3:stop[i-1]+3]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseMild.append(localTemp0)
            rrmseMild.append(localTemp1)
            rrMild.append(localTemp2)
            maeMild.append(localTemp3)
            
    print("rmse in Mild is",rmseMild)
    print("rrmse in Mild is",rrmseMild)
    print("rr in Mild is",rrMild)
    print("mae in Mild is",maeMild)
    print("\n")

    for i in mild:
            localSliceForDiffWeatherType = dn[start[i-1]:stop[i-1]]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseMildCs.append(localTemp0)
            rrmseMildCs.append(localTemp1)
            rrMildCs.append(localTemp2)
            maeMildCs.append(localTemp3)
            
    print("rmseCs in Mild is",rmseMildCs)
    print("rrmseCs in Mild is",rrmseMildCs)
    print("rrCs in Mild is",rrMildCs)
    print("maeCs in Mild is",maeMildCs)
    print("\n")
    ############Overcast##############
    rmseOvercast=[]
    rrmseOvercast=[]
    rrOvercast=[]
    maeOvercast=[]

    rmseOvercastCs=[]
    rrmseOvercastCs=[]
    rrOvercastCs=[]
    maeOvercastCs=[]
    
    for i in overcast:
            localSliceForDiffWeatherType = yn_1[start[i-1]+3:stop[i-1]+3]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseOvercast.append(localTemp0)
            rrmseOvercast.append(localTemp1)
            rrOvercast.append(localTemp2)
            maeOvercast.append(localTemp3)
    print("rmse in Overcast is",rmseOvercast)
    print("rrmse in Overcast is",rrmseOvercast)
    print("rr in Overcast is",rrOvercast)
    print("mae in Overcast is",maeOvercast)
    print("\n")

    for i in overcast:
            localSliceForDiffWeatherType = dn[start[i-1]:stop[i-1]]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseOvercastCs.append(localTemp0)
            rrmseOvercastCs.append(localTemp1)
            rrOvercastCs.append(localTemp2)
            maeOvercastCs.append(localTemp3)
    print("rmseCs in Overcast is",rmseOvercastCs)
    print("rrmseCs in Overcast is",rrmseOvercastCs)
    print("rrCs in Overcast is",rrOvercastCs)
    print("maeCs in Overcast is",maeOvercastCs)
    print("\n")
   ############Overcast##############
    rmseAbnormal=[]
    rrmseAbnormal=[]
    rrAbnormal=[]
    maeAbnormal=[]

    rmseAbnormalCs=[]
    rrmseAbnormalCs=[]
    rrAbnormalCs=[]
    maeAbnormalCs=[]
    
    for i in abnormal:
            localSliceForDiffWeatherType = yn_1[start[i-1]+3:stop[i-1]+3]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseAbnormal.append(localTemp0)
            rrmseAbnormal.append(localTemp1)
            rrAbnormal.append(localTemp2)
            maeAbnormal.append(localTemp3)
    print("rmse in Abnormal is",rmseAbnormal)
    print("rrmse in Abnormal is",rrmseAbnormal)
    print("rr in Abnormal is",rrAbnormal)
    print("mae in Abnormal is",maeAbnormal)
    print("\n")

    for i in abnormal:
            localSliceForDiffWeatherType = dn[start[i-1]:stop[i-1]]
            localSliceForDiffWearherType1 = x1n[start[i-1]:stop[i-1]]
            localTemp0, localTemp1 = rRMSE(localSliceForDiffWeatherType,localSliceForDiffWearherType1,0,len(localSliceForDiffWeatherType)-1,0)
            localTemp2 = RR_Cal(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            localTemp3 = Mae(localSliceForDiffWeatherType, localSliceForDiffWearherType1, 0, len(localSliceForDiffWeatherType)-1, 0)
            rmseAbnormalCs.append(localTemp0)
            rrmseAbnormalCs.append(localTemp1)
            rrAbnormalCs.append(localTemp2)
            maeAbnormalCs.append(localTemp3)
    print("rmseCs in Abnormal is",rmseAbnormalCs)
    print("rrmseCs in Abnormal is",rrmseAbnormalCs)
    print("rrCs in Abnormal is",rrAbnormalCs)
    print("maeCs in Abnormal is",maeAbnormalCs)
    print("\n")
    ############自相关法求每天移位################3
    temp1 = yn_1[2400:2500].tolist()
    temp2 = x1n[2400:2500].tolist()
    shift1 = InterCor_Cal(temp2,temp1,100)
    print(shift1)
    #print(temp1)
    print("\n")
   
####################plot area##########################################
   
   
    mydpi = 1000
    
    plt.figure(10)

    fontsize10 = 15
    
    plt.plot(dailyVolumn1,label="V$\mathsf{_f}$",marker="v",linewidth=2)
    plt.legend(fontsize=fontsize10)
    
    #plt.plot(dailyVolumn2,label="daily volumn u=0.0002 M=9")
    #plt.legend(fontsize=15)
    #plt.plot(dailyVolumn5,label="daily volumn u=0.0005 M=9")
    #plt.legend(fontsize=15)
    
    plt.plot(dailyVolumnSensor,label ="V$\mathsf{_s}$",linestyle="-.",marker="o",linewidth=2)
    ############plt.legend(fontsize=20)
    plt.plot(dailyVolumnCal,label="V$\mathsf{_c}$",linestyle="--",marker="s",linewidth=2)
    ############plt.legend(fontsize=20)
    ############plt.legend(loc='best', ncol=3,fancybox=True,shadow=True)
    plt.xlim(-0.30,25.3)
    plt.ylim(100,750)
    plt.xticks([0,4,9,14,19,24],["Dec-1","Dec-5","Dec-10","Dec-15","Dec-20","Dec-25"],fontsize=fontsize10)
    ############plt.legend()
    plt.yticks([100,200,300,400,500,600,700],fontsize=fontsize10)
    ############plt.legend()
    
    #plt.title("Daily Volumn calculated by 3 methods  ",fontsize=15)
    #plt.legend()
    plt.xlabel("Date",fontsize=fontsize10)
    ############plt.legend()
    plt.ylabel("Volume (mL $\mathsf {plant^{-1}})$",fontsize=fontsize10)
    plt.legend(loc='best', ncol=3,fancybox=False,shadow=False, fontsize=fontsize10)                                                    #可加fontsize改变字体大小，只有最后一次使用有效
    plt.grid()
    plt.savefig(r'C:\Users\Administrator\Desktop\小论文\三次上传\Figures\high resolution\fig6.png', dpi=mydpi)

    
    plt.figure(11)
    fontsize11 = 15
    plt.plot(dailyVolumnDeltaFS1,label="PE$\mathsf{_{fs}}$",marker="o",linewidth=3)
    #plt.legend(fontsize=20)
    plt.plot( dailyVolumnDeltaCS,label="PE$\mathsf{_{cs}}$",marker="s",linewidth=3)
    #plt.legend(fontsize=20)
    
    plt.plot(dayliAvrClearness,label="Daily average K$\mathsf{_{t}}$",marker="v",linestyle="--",linewidth=3)
    #plt.legend(fontsize=20)
   
    plt.xlabel("Date",fontsize=fontsize11)
    plt.legend()
    plt.ylabel("Percentage (%)",fontsize=fontsize11)
    plt.legend()
    plt.xlim(-0.30,25.3)
    plt.ylim(-0.05,1.0)
    plt.xticks([0,4,9,14,19,24],["Dec-1","Dec-5","Dec-10","Dec-15","Dec-20","Dec-25"], fontsize=fontsize11)
    plt.legend()
    plt.yticks([0,0.2,0.4,0.6,0.8,1.0],["0","20","40","60","80","100"], fontsize=fontsize11)
    plt.legend(fontsize=fontsize11-2)
    #plt.title("Daily Volumn Delta and Average Clearness ",fontsize=15)
    #plt.legend()
    #plt.plot(Thd,label="THD")
    #plt.legend()
    plt.grid()
    plt.savefig(r'C:\Users\Administrator\Desktop\小论文\三次上传\Figures\high resolution\fig8.png', dpi=mydpi)
   

    plt.figure(13)
    fontsize13 = 12
   # plt.scatter(localSlice2, localSlice1,marker ='o',c='',edgecolors='k')
   # plt.legend(fontsize=20)
   # plt.scatter(localSlice3, localSlice1,marker ='s',c='',edgecolors='k')
   # plt.legend(fontsize=20)
    fit_curve=[]
    fit_curve1=[]
    fit_curve_1to1=[]
    temp = 0
    temp1 = 0
    temp2 = 0
    for i in range(len(localSlice2)):
            temp = A1*localSlice2[i]+B1
            fit_curve.append(temp)
            
            temp1 = localSlice2[i]
            fit_curve_1to1.append(temp1)

            temp2 = A3*localSlice2[i]+B3
            fit_curve1.append(temp2)
    plt.subplot(2,1,1)
    plt.scatter(localSlice2, localSlice1,marker ='o',c='',edgecolors='k')
    ############plt.legend(fontsize=20)																			#画图前只用一次
	############plt.plot(localSlice2, fit_curve, linewidth="3",label="fit_fs",color='k')       					#修改，见下行
    plt.plot(localSlice2, fit_curve, linewidth="3",color='k')
	#--原注释代码
	# plt.plot(localSlice3, fit_curve1, linewidth="3",label="fit_Cs",color='k',linestyle=":")
	# plt.legend(fontsize=20)																						
	#--end
    #############plt.plot(localSlice2, fit_curve_1to1, linewidth="1.5",label="y=x",color='red',linestyle=":")	#修改，见下行
    #plt.plot(localSlice2, fit_curve_1to1, linewidth="1.5",color='red',linestyle=":")  	#accroding to comment of reviewer1
    #############plt.legend(fontsize=20)																		#画图前只用一次
	#--原注释代码
    #plt.xlabel("H$\mathsf{_s}$ $\mathsf{W} \mathsf {m^{-2}}$",fontsize=20)
    #plt.legend()
	#--end
    plt.ylabel("H$\mathsf{_f}$ ($\mathsf{W} \mathsf {m^{-2}}$)",fontsize=fontsize13)
    #############plt.legend()
    #plt.xlabel("H$\mathsf{_s}$ ($\mathsf{W} \mathsf {m^{-2}}$)",fontsize=20)
    #############plt.legend()
    plt.xlim(-0.1,4)
    plt.ylim(-0.1,4)
    plt.xticks([0,0.5,1,1.5,2,2.5,3,3.5,4],[0,50,100,150,200,250,300,350,400],fontsize=fontsize13)
    #############plt.legend()
    plt.yticks([0,0.5,1,1.5,2,2.5,3,3.5,4],[0,50,100,150,200,250,300,350,400],fontsize=fontsize13)
    plt.legend(["fit$\mathsf{_{fs}}$"],loc = 'lower right',fontsize=fontsize13)                                                       				#fontsize:P13-1图例文字大小
   
    #plt.text(0.5,3.5,"(a)",fontsize=20)
    plt.title("(a)", fontsize = fontsize13)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=0.3)
    plt.grid()
    
    plt.subplot(2,1,2)
    plt.scatter(localSlice2, localSlice3,marker ='o',c='',edgecolors='k')
    #############plt.legend(fontsize=20)
	#--原注释代码
    #plt.plot(localSlice2, fit_curve, linewidth="3",label="fit_Fs",color='k')
    #plt.legend(fontsize=20)
	#--end
    #############plt.plot(localSlice2, fit_curve1, linewidth="3",label="fit_cs",color='k')
    plt.plot(localSlice2, fit_curve1, linewidth="3",color='k')
    #############plt.legend(fontsize=20)
    #############plt.plot(localSlice2, fit_curve_1to1, linewidth="1.5",label="y=x",color='red',linestyle=":")
    #plt.plot(localSlice2, fit_curve_1to1, linewidth="1.5",color='red',linestyle=":") #accroding to comment of reviewer1
    #############plt.legend(fontsize=20)
    plt.xlabel("H$\mathsf{_s}$ ($\mathsf{W} \mathsf {m^{-2}}$)",fontsize=fontsize13)
    #############plt.legend()
    plt.ylabel("H$\mathsf{_c}$ ($\mathsf{W} \mathsf {m^{-2}}$)",fontsize=fontsize13)
    #############plt.legend()
    plt.xlim(-0.1,4)
    plt.ylim(-0.1,4)
    plt.xticks([0,0.5,1,1.5,2,2.5,3,3.5,4],[0,50,100,150,200,250,300,350,400],fontsize=fontsize13)
    #############plt.legend()
    plt.yticks([0,0.5,1,1.5,2,2.5,3,3.5,4],[0,50,100,150,200,250,300,350,400],fontsize=fontsize13)
    #############plt.legend()
    #plt.text(0.5,3.5,"(b)",fontsize=20)
    plt.title("(b)",fontsize = fontsize13)
    plt.legend(["fit$\mathsf{_{cs}}$"], loc = 'lower right', fontsize=fontsize13)                                                                     #fontsize:P13-2图例文字大小
    plt.grid()
    plt.savefig(r'C:\Users\Administrator\Desktop\小论文\三次上传\Figures\high resolution\fig4.png', dpi=mydpi)
    
    plt.figure(14)
    fontsize14 = 12
    plt.scatter(dailyVolumnSensor,dailyVolumn1,marker ='o',c='',edgecolors='k',label="V$\mathsf {_f}$")
    #plt.legend(fontsize=20)
    plt.scatter(dailyVolumnSensor,dailyVolumnCal,marker ='s',color="k",label="V$\mathsf {_c}$")
    #plt.legend(fontsize=20)
    fit_curve=[]
    fit_curve1=[]
    fit_curve_1to1=[]
    temp = 0
    temp1 = 0
    temp2 = 0
    for i in range(len(dailyVolumn1)):
            temp = A2*dailyVolumnSensor[i]+B2
            fit_curve.append(temp)
            temp1 = dailyVolumnSensor[i]
            fit_curve_1to1.append(temp1)
            temp2 = A4*dailyVolumnSensor[i]+B4
            fit_curve1.append(temp2)
    plt.plot(dailyVolumnSensor, fit_curve, linewidth="1.5",label="fit$\mathsf{_{fs}}$",color='k')
    #plt.legend(fontsize=20)
    plt.plot(dailyVolumnSensor, fit_curve1, linewidth="1.5",label="fit$\mathsf{_{cs}}$",color='blue')
    #plt.legend(fontsize=20)
    #plt.plot(dailyVolumnSensor, fit_curve_1to1, linewidth="1.5",label="y=x",color='red',linestyle=":")
    #plt.legend(fontsize=20)
    plt.xlabel("V$\mathsf{_s}($ mL $\mathsf {plant^{-1}}$)",fontsize=fontsize14)
    #plt.legend()
    plt.ylabel("Water volume (mL $\mathsf {plant^{-1}}$)",fontsize=fontsize14)
    #plt.legend()
    plt.xlim(100,750)
    plt.ylim(100,750)
    plt.xticks([100,200,300,400,500,600,700],fontsize=fontsize14)
    #plt.legend()
    plt.yticks([100,200,300,400,500,600,700], fontsize=fontsize14)
    plt.legend(loc='best', ncol=1,fancybox=False,shadow=False, fontsize=fontsize14)
    #plt.title("Scatter Plot of Vs-Vf")
    plt.grid()
    plt.savefig(r'C:\Users\Administrator\Desktop\小论文\三次上传\Figures\high resolution\fig7.png', dpi=mydpi)

    
    plt.figure(15)
    plt.xticks([0,4,9,14,19,24],["Dec-1","Dec-5","Dec-10","Dec-15","Dec-20","Dec-25"],fontsize=15)
    plt.legend(fontsize=20)
   
    plt.plot(GDD,marker="v",linewidth=3,color="k",label = "GDD")
   
    plt.ylim(1250,1350)
    plt.legend()
    plt.yticks([1250,1270,1290,1310,1330,1350],fontsize=15)
    plt.legend(fontsize=20)
    plt.xlabel("Date",fontsize=20)
    plt.legend()
    plt.ylabel("Growing Degree Days(GDD)",fontsize=20)
    plt.legend(fontsize=20)
    plt.grid()
    #plt.title("GDD in December")
    
    
    plt.figure(16)
    buf = []
    for i in range(len(innerAccordingClearness)):
            innerAccordingClearness[i] /= 100
    plt.plot(innerAccordingClearness,label="cal")
    plt.legend()
    for i in range(len(lightOuter)):
            buf.append(lightOuter[i]/100)
    plt.plot(buf,label="outter")
    plt.legend()
    plt.plot(x1n,label="sen")
    plt.legend()
    plt.plot(yn_1[3:len(yn_1)-3],label="fil")
    
    plt.legend()
    plt.grid()
    
    fig = plt.figure(17)#########sunny
    sunny = [11,12]#1 3 4 11 12
    out_slice_plot=[]
    fil_slice_plot=[]
    cal_slice_plot=[]
    sen_slice_plot=[]
    t3 = []
    
    fontsize17 = 10
    linewidth17 = 2
    #fil_slice_plot.extend([0,0,0,0])
    for i in sunny:
            for j in range(start[i],stop[i]):
                    t3.append(j*15)
    print("len of t3 is",len(t3))
            
    out_slice_plot.extend( buf[980+5:1030+5] )
    out_slice_plot.extend( buf[1075+5:1125+5] )
    #out_slice_plot.extend( buf[1650:1710] )

    fil_slice_plot.extend( yn_1[980+5+3:1030+5+3])
    fil_slice_plot.extend( yn_1[1075+5+3:1125+5+3])
    #fil_slice_plot.extend( yn[1650:1710])
            
    cal_slice_plot.extend( dn[980+5:1030+5] )
    cal_slice_plot.extend( dn[1075+5:1125+5] )
    #cal_slice_plot.extend( dn[1650:1710] )
           
    sen_slice_plot.extend( x1n[980+5:1030+5] )
    sen_slice_plot.extend( x1n[1075+5:1125+5] )
    #sen_slice_plot.extend( x1n[1650:1710] )
    
    ax1 = plt.subplot(2,2,3)
    plt.legend(fontsize = fontsize17)
    plt.xlabel("Time",fontsize = fontsize17)
    plt.legend()
    plt.xticks([  5,22,40,55,72,89],
               ['8:00','12:00\nDec-11','16:00',
                
                 
                '8:00','12:00\nDec-12','16:00'
                ],fontsize = fontsize17-2)
    #plt.xticks(rotation=0)
    #plt.text(0.5,3.5,"(c)",fontsize=20)
    plt.legend()
    plt.legend(fontsize = 15)
    plt.yticks([0,1,2,3,4,5,6],[0,100,200,300,400,500,600],fontsize = fontsize17-2)
    plt.legend()
    
    plt.plot(out_slice_plot,linestyle=":",label="H$\mathsf {_{out}}$",linewidth=linewidth17)
    plt.legend(fontsize = fontsize17)
    plt.plot(fil_slice_plot,linestyle='-',label="H$\mathsf {_f}$",linewidth=linewidth17,color='black')
    plt.legend(fontsize = fontsize17)
    plt.plot(cal_slice_plot,linestyle="-",label="H$\mathsf {_c}$",linewidth=linewidth17,color="red")
    plt.legend(fontsize = fontsize17)
    plt.plot(sen_slice_plot,linestyle="-",label="H$\mathsf {_s}$",linewidth=linewidth17,color='blue')
    plt.legend(fontsize = fontsize17)
    #plt.ylabel(r"Solar Radiation   ($\mathsf{W}\,\mathsf{m^{-2}}$)",fontsize = my_fontsize)
    ax1.legend(loc=1, bbox_to_anchor=(1.5,1.0),borderaxespad = 0.,fontsize = fontsize17)
    ax1.set_ylabel(r"Solar Radiation   ($\mathsf{W}\,\mathsf{m^{-2}}$)", y=1.2,fontsize = fontsize17)
    ax1.set_xlabel("Time",fontsize = fontsize17-2, x = 1)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=0.3)
    plt.title("\n(c)",fontsize = fontsize17)
    plt.grid()
    #ax1.legend_.remove()

    
    #fig = plt.figure(18)#overcast
    #overcast = [2,8,14]#1 3 4 11 12
    out_slice_plot=[]
    fil_slice_plot=[]
    cal_slice_plot=[]
    sen_slice_plot=[]
    t3 = []
   
    
    out_slice_plot.extend( buf[120:176] )
    out_slice_plot.extend( buf[695:745] )
    #out_slice_plot.extend( buf[1650:1710] )

    fil_slice_plot.extend( yn_1[120+1:176+1])
    fil_slice_plot.extend( yn_1[695+1:745+1])
    #fil_slice_plot.extend( yn[1650:1710])
            
    cal_slice_plot.extend( dn[120:176] )
    cal_slice_plot.extend( dn[695:745] )
    #cal_slice_plot.extend( dn[1650:1710] )
           
    sen_slice_plot.extend( x1n[120:176] )
    sen_slice_plot.extend( x1n[695:745] )
    #sen_slice_plot.extend( x1n[1650:1710] )
    
    ax3 = plt.subplot(2,2,1)
    plt.legend(fontsize = fontsize17)
    plt.legend(loc='best', bbox_to_anchor=(0.9,0.95),ncol=3,fancybox=True,shadow=True)
    #plt.xlabel("Time",fontsize = my_fontsize)
    plt.legend()
    
    plt.xticks([  6,23,39,63,80,96],
               ['8:00','12:00\nDec-2','16:00',
                #'8:00','12:00\nDec3','16:00',
                #'8:00\nDec3','12:00\nDec3','16:00\nDec3',
                '8:00','12:00\nDec-8','16:00'],fontsize = fontsize17-2)
                #'8:00','12:00\nDec14','16:00'])
    plt.xticks(rotation=0)
    plt.legend(fontsize=fontsize17)
    #plt.text(0.5,3.5,"(a)",fontsize=20)# 回复审稿人高度为2.5， 全图高度3.5
    plt.yticks([0,1,2,3,4,5,6],[0,100,200,300,400,500,600],fontsize = fontsize17-2)
    plt.legend()
    
    plt.plot(out_slice_plot,linestyle=":",label="H$\mathsf {_{out}}$",linewidth=linewidth17)
    plt.legend(fontsize = fontsize17)
   
    plt.plot(cal_slice_plot,linestyle="-",label="H$\mathsf {_c}$",linewidth=linewidth17,color="red")
    plt.legend(fontsize = fontsize17)
    plt.plot(sen_slice_plot,linestyle="-",label="H$\mathsf {_s}$",linewidth=linewidth17,color='blue')
    plt.legend(fontsize = fontsize17)
    plt.plot(fil_slice_plot,linestyle='-',label="H$\mathsf {_f}$",linewidth=linewidth17,color='black')
    plt.legend(fontsize = fontsize17) 
   # plt.ylabel(r"Solar Radiation   ($\mathsf{W}\,\mathsf{m^{-2}}$)",fontsize = my_fontsize)
   # ax3.legend(loc=1, bbox_to_anchor=(1.5,1.0),borderaxespad = 0.,fontsize = my_fontsize)
   # ax3.set_ylabel(r"Solar Radiation   ($\mathsf{W}\,\mathsf{m^{-2}}$)", y=1.2,fontsize = my_fontsize)
   # ax3.set_xlabel("Time",fontsize = my_fontsize, x = 1)
    ax3.legend_.remove()
    plt.title("(a)",fontsize = fontsize17 )
    plt.grid()
    
    

    #fig = plt.figure(19)#cloudy
    #overcast = [2,8,14]#1 3 4 11 12
    out_slice_plot=[]
    fil_slice_plot=[]
    cal_slice_plot=[]
    sen_slice_plot=[]
    t3 = []
  
    
    out_slice_plot.extend( buf[410:460] )
    out_slice_plot.extend( buf[890:940] )
    #out_slice_plot.extend( buf[1650:1710] )

    fil_slice_plot.extend( yn_1[410+3:460+3])
    fil_slice_plot.extend( yn_1[890+3:940+3])
    #fil_slice_plot.extend( yn[1650:1710])
            
    cal_slice_plot.extend( dn[410:460] )
    cal_slice_plot.extend( dn[890:940] )
    #cal_slice_plot.extend( dn[1650:1710] )
           
    sen_slice_plot.extend( x1n[410:460] )
    sen_slice_plot.extend( x1n[890:940] )
    #sen_slice_plot.extend( x1n[1650:1710] )
    ax2 = plt.subplot(2,2,2)        
    plt.legend(loc='best', bbox_to_anchor=(0.9,0.95),ncol=3,fancybox=True,shadow=True)
    #plt.xlabel("Time",fontsize = 15)
    plt.legend()
    
    plt.xticks([  3,20,37,54,71,88],
               ['8:00','12:00\nDec-5','16:00',
                #'8:00','12:00\nDec3','16:00',
                #'8:00\nDec3','12:00\nDec3','16:00\nDec3',
                '8:00','12:00\nDec-10','16:00'],fontsize = fontsize17-2)
                #'8:00','12:00\nDec14','16:00'])
    plt.xticks(rotation=0)
    plt.legend(fontsize = 6)
    #plt.text(0.5,3.5,"(b)",fontsize=20)
    plt.yticks([0,1,2,3,4,5,6],[0,100,200,300,400,500,600],fontsize = fontsize17-2)
    plt.legend()
    
    plt.plot(out_slice_plot,linestyle=":",label="H$\mathsf {_{out}}$",linewidth=linewidth17)
    plt.legend(fontsize = fontsize17)
    plt.plot(fil_slice_plot,linestyle='-',label="H$\mathsf {_f}$",linewidth=linewidth17,color='black')
    plt.legend(fontsize = fontsize17)
    plt.plot(cal_slice_plot,linestyle="-",label="H$\mathsf {_c}$",linewidth=linewidth17,color="red")
    plt.legend(fontsize = fontsize17)
    plt.plot(sen_slice_plot,linestyle="-",label="H$\mathsf {_s}$",linewidth=linewidth17,color='blue')
    plt.legend(fontsize = fontsize17)
    #plt.ylabel(r"Solar Radiation   ($\mathsf{W}\,\mathsf{m^{-2}}$)",fontsize = 15)
    ax2.legend_.remove()
    plt.title("(b)",fontsize = fontsize17 )
    plt.grid()

    plt.savefig(r'C:\Users\Administrator\Desktop\小论文\三次上传\Figures\high resolution\fig3.png', dpi=mydpi)
    
    fig = plt.figure(20)#abnormal
    #overcast = [2,8,14]#1 3 4 11 12
    out_slice_plot=[]
    fil_slice_plot=[]
    cal_slice_plot=[]
    sen_slice_plot=[]
    t3 = []
   
    
    out_slice_plot.extend( buf[790:850] )
    #out_slice_plot.extend( buf[890:940] )
    #out_slice_plot.extend( buf[1650:1710] )

    fil_slice_plot.extend( yn_1[790+3:850+3])
    #fil_slice_plot.extend( yn[890:940])
    #fil_slice_plot.extend( yn[1650:1710])
            
    cal_slice_plot.extend( dn[790:850] )
    #cal_slice_plot.extend( dn[890:940] )
    #cal_slice_plot.extend( dn[1650:1710] )
           
    sen_slice_plot.extend( x1n[790:850] )
    #sen_slice_plot.extend( x1n[890:940] )
    #sen_slice_plot.extend( x1n[1650:1710] )
            
    plt.legend(loc='best', bbox_to_anchor=(0.9,0.95),ncol=3,fancybox=True,shadow=True)
    plt.xlabel("Time",fontsize = 15)
    plt.legend()
    
    plt.xticks([  6+4,22+4,38+4],
               ['8:00','12:00\nDec-9','16:00'],fontsize = 15)
               
    plt.xticks(rotation=0)
    plt.legend(fontsize = 6)
    
    plt.yticks([0,1,2,3,4,5,6],[0,100,200,300,400,500,600],fontsize = 15)
    plt.legend()
    
    plt.plot(out_slice_plot,linestyle=":",label="H$\mathsf {_{out}}$",linewidth=3.5)
    plt.legend(fontsize = 15)
    plt.plot(fil_slice_plot,linestyle='-',label="H$\mathsf {_f}$",linewidth=3.5,color='black')
    plt.legend(fontsize = 15)
    plt.plot(cal_slice_plot,linestyle="-",label="H$\mathsf {_c}$",linewidth=3.5,color="red")
    plt.legend(fontsize = 15)
    plt.plot(sen_slice_plot,linestyle="-",label="H$\mathsf {_s}$",linewidth=3.5,color='blue')
    plt.legend(fontsize = 15)
    plt.ylabel(r"Solar Radiation   ($\mathsf{W}\,\mathsf{m^{-2}}$)",fontsize = 15)
    plt.grid()

    plt.figure(21)
    thd_fig21temp=0
    thd_fig21=[]
    plt.semilogy()
    hdistance = 0.5

    fontsize21 = 15
    ax1 = plt.subplot(3,2,1)
    plt.semilogy()
    nFFT = 0
    lenthOfThd = 0
    i = (sunny[0])
    nFFT = len(xn[start[i-1]:stop[i-1]])*2
    for j in range(start[i-1],stop[i-1]):
        
        dataNorm =Normalization(abs(fft(W_Final[j],nFFT)))
        dataNorm = dataNorm[0:int(nFFT/2)]
        if j == start[i-1]:
           plt.plot(dataNorm,color = "k",label = "Frequency response of LMS")
           plt.legend()
        else:
           plt.plot(dataNorm,color = "k")
           plt.legend()
    a = abs(fft(xn[start[i-1]:stop[i-1]],nFFT)[0:int(nFFT/2)])
    a = Normalization(a)
    lenthOfThd = int(nFFT/2)
    thd_fig21temp = Thd_Cal(a[0:lenthOfThd])
    thd_fig21.append(thd_fig21temp)
    plt.plot(a,label="FFT of H$\mathsf {_{out}}$")
    plt.legend()
    #plt.text(4.2,0.6,"(a)",fontsize=20)                                          #0.1改为0.6
    #plt.hlines(0.707, 0, nFFT/2)
    #plt.vlines(6,0.001,1)
    plt.yticks([0.1,1],["-20","0"],fontsize = fontsize21-5)
    plt.xticks([0,0.2*nFFT/2,0.4*nFFT/2,0.6*nFFT/2,0.8*nFFT/2,nFFT/2],["0","0.1$\mathsf{\pi}$","0.2$\mathsf{\pi}$","0.3$\mathsf{\pi}$","0.4$\mathsf{\pi}$","0.5$\mathsf{\pi}$"], fontsize =fontsize21-5)
    plt.title("(a)", fontsize = fontsize21-5)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=hdistance)
    #plt.text(200,0.5,"DEC11",fontsize=10)
    #plt.xlabel("Normalized frequency (rad)",fontsize=12)
    #plt.ylabel("Normalized magnitude (dB)",fontsize=12)
    
    plt.grid()
    
    ax2 = plt.subplot(3,2,2)
    plt.semilogy()
    i = (sunny[1])
    nFFT = len(xn[start[i-1]:stop[i-1]])*2
    for j in range(start[i-1],stop[i-1]):
        dataNorm =Normalization(abs(fft(W_Final[j],nFFT)))
        dataNorm = dataNorm[0:int(nFFT/2)]
        if j == start[i-1]:
           plt.plot(dataNorm,color = "k",label = "Frequency response of LMS")
           plt.legend()
        else:
           plt.plot(dataNorm,color = "k")
           plt.legend()

    a = abs(fft(xn[start[i-1]:stop[i-1]],nFFT)[0:int(nFFT/2)])
    a = Normalization(a)
    lenthOfThd = int(nFFT/2)
    thd_fig21temp = Thd_Cal(a[0:lenthOfThd])
    thd_fig21.append(thd_fig21temp)
    plt.plot(a,label="FFT of H$\mathsf {_{out}}$")
    plt.legend()
    #plt.text(4.2,0.6,"(b)",fontsize=20)                                          #0.1改为0.6
    #plt.hlines(0.707, 0, nFFT/2)
    #plt.vlines(6,0.001,1)
    plt.yticks([0.1,1],["-20","0"],fontsize = fontsize21-5)
    plt.xticks([0,0.2*nFFT/2,0.4*nFFT/2,0.6*nFFT/2,0.8*nFFT/2,nFFT/2],["0","0.1$\mathsf{\pi}$","0.2$\mathsf{\pi}$","0.3$\mathsf{\pi}$","0.4$\mathsf{\pi}$","0.5$\mathsf{\pi}$"], fontsize = fontsize21-5)
    #plt.xlabel("Normalized frequency (rad)",fontsize=12)
    #plt.ylabel("Normalized magnitude (dB)",fontsize=12)
    plt.title("(b)", fontsize  = fontsize21-5)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=hdistance)
    plt.grid()
    
    ax3 = plt.subplot(3,2,3)
    plt.semilogy()
    i = (mild[0])
    nFFT = len(xn[start[i-1]:stop[i-1]])*2
    for j in range(start[i-1],stop[i-1]):
        dataNorm =Normalization(abs(fft(W_Final[j],nFFT)))
        dataNorm = dataNorm[0:int(nFFT/2)]
        if j == start[i-1]:
           plt.plot(dataNorm,color = "k",label = "Frequency response of LMS")
           plt.legend()
        else:
           plt.plot(dataNorm,color = "k")
           plt.legend()
        
    a = abs(fft(xn[start[i-1]:stop[i-1]],nFFT)[0:int(nFFT/2)])
    a = Normalization(a)
    lenthOfThd = int(nFFT/2)
    thd_fig21temp = Thd_Cal(a[0:lenthOfThd])
    thd_fig21.append(thd_fig21temp)
    plt.plot(a,label="FFT of H$\mathsf {_{out}}$")
    plt.legend()
    #plt.text(4.2,0.6,"(c)",fontsize=20)										   #0.1改为0.6
    plt.legend()
    #plt.hlines(0.707, 0, nFFT/2)
    #plt.vlines(6,0.001,1)
    plt.yticks([0.1,1],["-20","0"],fontsize = fontsize21-5)
    plt.xticks([0,0.2*nFFT/2,0.4*nFFT/2,0.6*nFFT/2,0.8*nFFT/2,nFFT/2],["0","0.1$\mathsf{\pi}$","0.2$\mathsf{\pi}$","0.3$\mathsf{\pi}$","0.4$\mathsf{\pi}$","0.5$\mathsf{\pi}$"],fontsize = fontsize21-5)
    #plt.xlabel("Normalized frequency (rad)",fontsize=12)
    plt.ylabel("Normalized magnitude (dB)",fontsize=fontsize21-5)
    plt.title("(c)", fontsize = fontsize21-5)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=hdistance)
    plt.grid()
    
    ax4 = plt.subplot(3,2,4)
    plt.semilogy()
    i = (mild[1])
    nFFT = len(xn[start[i-1]:stop[i-1]])*2
    for j in range(start[i-1],stop[i-1]):
        dataNorm =Normalization(abs(fft(W_Final[j],nFFT)))
        dataNorm = dataNorm[0:int(nFFT/2)]
        if j == start[i-1]:
           plt.plot(dataNorm,color = "k",label = "Frequency response of LMS")
           plt.legend()
        else:
           plt.plot(dataNorm,color = "k")
           plt.legend()
   
    a = abs(fft(xn[start[i-1]:stop[i-1]],nFFT)[0:int(nFFT/2)])
    a = Normalization(a)
    lenthOfThd = int(nFFT/2)
    thd_fig21temp = Thd_Cal(a[0:lenthOfThd])
    thd_fig21.append(thd_fig21temp)
    plt.plot(a,label="FFT of H$\mathsf {_{out}}$")
    plt.legend()    
    #plt.text(4.2,0.6,"(d)",fontsize=20)                                          #0.1改为0.6
    #plt.hlines(0.707, 0, nFFT/2)
    #plt.vlines(6,0.001,1)
    plt.xticks([0,0.2*nFFT/2,0.4*nFFT/2,0.6*nFFT/2,0.8*nFFT/2,nFFT/2],["0","0.1$\mathsf{\pi}$","0.2$\mathsf{\pi}$","0.3$\mathsf{\pi}$","0.4$\mathsf{\pi}$","0.5$\mathsf{\pi}$"],fontsize = fontsize21-5)
    plt.yticks([0.1,1],["-20","0"],fontsize = fontsize21-5)
    #plt.xlabel("Normalized frequency (rad)",fontsize=12)
    #plt.ylabel("Normalized magnitude (dB)",fontsize=12)
    plt.title("(d)", fontsize = fontsize21-5)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=hdistance)
    plt.grid()
    
    ax5 = plt.subplot(3,2,5)
    plt.semilogy()
    i  = 2
    nFFT = len(xn[start[i-1]:stop[i-1]])*4
    for j in range(start[i-1],stop[i-1]):
        dataNorm =Normalization(abs(fft(W_Final[j],nFFT)))
        dataNorm = dataNorm[0:int(nFFT/2)]
        if j == start[i-1]:
           plt.plot(dataNorm,color = "k",label = "Frequency response of LMS")
           plt.legend()
        else:
           plt.plot(dataNorm,color = "k")
           plt.legend()

    a = abs(fft(xn[start[i-1]:stop[i-1]],nFFT)[0:int(nFFT/2)])
    a = Normalization(a)
    #print("e",a)
    lenthOfThd = int(nFFT/2)
    thd_fig21temp = Thd_Cal(a[0:lenthOfThd])
    thd_fig21.append(thd_fig21temp)
    plt.plot(a,label="FFT of H$\mathsf {_{out}}$")
    plt.legend()
    #plt.text(5,0.6,"(e)",fontsize=20)                                          #0.1改为0.6
   # plt.hlines(0.707, 0, nFFT/2)
   # plt.vlines(6,0.001,1)
    
    plt.xticks([0,0.2*nFFT/2,0.4*nFFT/2,0.6*nFFT/2,0.8*nFFT/2,nFFT/2],["0","0.1$\mathsf{\pi}$","0.2$\mathsf{\pi}$","0.3$\mathsf{\pi}$","0.4$\mathsf{\pi}$","0.5$\mathsf{\pi}$"],fontsize = fontsize21-5)
    plt.yticks([0.1,1],["-20","0"],fontsize = fontsize21-5)
    #plt.xlabel("Normalized frequency (rad)",fontsize=12)
    #plt.ylabel("Normalized magnitude (dB)",fontsize=12)
    plt.title("(e)", fontsize = fontsize21-5)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=hdistance)
    plt.grid()
    
    ax6 = plt.subplot(3,2,6)
    plt.semilogy()
    i = 8
    nFFT = len(xn[start[i-1]:stop[i-1]])*4
    for j in range(start[i-1],stop[i-1]):
        dataNorm =Normalization(abs(fft(W_Final[j],nFFT)))
        dataNorm = dataNorm[0:int(nFFT/2)]
        if j == start[i-1]:
           plt.plot(dataNorm,color = "k",label = "Frequency response of LMS")
           plt.legend()
        else:
           plt.plot(dataNorm,color = "k")
           plt.legend()

    a = abs(fft(xn[start[i-1]:stop[i-1]],nFFT)[0:int(nFFT/2)])
    a = Normalization(a)
    lenthOfThd = int(nFFT/2)
    thd_fig21temp = Thd_Cal(a[0:lenthOfThd])
    thd_fig21.append(thd_fig21temp)
    plt.plot(a,label="FFT of H$\mathsf {_{out}}$")
    plt.legend()
    #plt.text(5.7,0.6,"(f)",fontsize=20)                                          #0.1改为0.6
    #plt.hlines(0.707, 0, nFFT/2)
    #plt.vlines(6,0.001,1)
    #plt.xlabel("Samples",fontsize=15)
    plt.xticks([0,0.2*nFFT/2,0.4*nFFT/2,0.6*nFFT/2,0.8*nFFT/2,nFFT/2],["0","0.1$\mathsf{\pi}$","0.2$\mathsf{\pi}$","0.3$\mathsf{\pi}$","0.4$\mathsf{\pi}$","0.5$\mathsf{\pi}$"],fontsize = fontsize21-5)
    plt.yticks([0.1,1],["-20","0"],fontsize = fontsize21-5)
    plt.title("(f)", fontsize = fontsize21-5)
    plt.subplots_adjust(left=None, bottom=None, right=None, top=None,
                wspace=None, hspace=hdistance)
    #plt.xlabel("Normalized frequency (rad)",fontsize=12)
    #plt.ylabel("Normalized magnitude (dB)",fontsize=12)
    ax2.legend_.remove()
    ax3.legend_.remove()
    ax4.legend_.remove()
    ax5.legend_.remove()
    ax6.legend_.remove()
    ax5.set_xlabel("Normalized frequency (rad)",fontsize = fontsize21-5, x=1)
    ax1.legend(loc=[1, 0], bbox_to_anchor=(0.56,1.05),fontsize = fontsize21-5, ncol=1, fancybox=True)#borderaxespad = 0.,
    plt.grid()
    print("thd series is",thd_fig21)
    plt.savefig(r'C:\Users\Administrator\Desktop\小论文\三次上传\Figures\high resolution\fig5.png', dpi=mydpi)
   

    plt.figure(23)
    plt.plot(tal_gDaily,marker="v",linewidth=2,label=r"Daily $\mathsf{\tau} \mathsf{_g}}$")
    #plt.legend()
    plt.plot(tal_gDailyAvr,linewidth=2,linestyle="--",label=r"Average value of daily $\mathsf{\tau} \mathsf{_g}}$")
    #plt.legend()
    plt.ylim(0,1)
    
    plt.yticks([0.00,0.10,0.20,0.30,0.40,0.50,0.60,0.70,0.80,0.90,1.00],[0.00,0.10,0.20,0.30,0.40,0.50,0.60,0.70,0.80,0.90,1.00],fontsize=20)
    plt.xticks([0,4,9,14,19,24],["Dec-1","Dec-5","Dec-10","Dec-15","Dec-20","Dec-25"],fontsize=20)
    plt.xlabel("Date",fontsize=20)
    plt.ylabel(r"$\mathsf{\tau} \mathsf{_g}}$",fontsize=20)
    plt.legend(loc='best', ncol=1,fancybox=False,shadow=False, fontsize=20)
    plt.grid()

    plt.figure(24)
    a1 = -0.335
    a2 = 4.803
    a3 = 755.3
    a4 = 134.7
    LAI_s = []
    
    for i in range(0 , len(GDD)-1):
        LAI_s.append(a1 + (a2 - a1)/(1 + math.exp((a3 - GDD[i])/a4)));

    #plt.plot(LAI_s)

    plt.xticks([0,4,9,14,19,24],["Dec-1","Dec-5","Dec-10","Dec-15","Dec-20","Dec-25"],fontsize=15)
    plt.legend(fontsize=20)
   
    plt.plot(LAI_s,marker="v",linewidth=3,color="k",label = "LAI")
   
    plt.ylim(4.5,5)
    plt.legend()
    plt.yticks([4.5,4.6,4.7,4.8,4.9,5.0],fontsize=15)
    plt.legend(fontsize=20)
    plt.xlabel("Date",fontsize=20)
    plt.legend()
    plt.ylabel("Leaf Index Area(LAI)",fontsize=20)
    plt.legend(fontsize=20)
    
    plt.grid()
    #plt.show()
    
